
Konzepte der Programmierung                       Universität Konstanz
Programmierkurs 2                Informatik & Informationswissenschaft
Sommer 2016                                Marc Scholl, Stefan Klinger

======================================================================

                             9. Mai 2016

----------------------------------------------------------------------
Organisatorisches


  * Wer braucht noch einen Übungspartner?

    ⇒ Bei mir melden, möglichst schnell...


----------------------------------------------------------------------


> import Prelude hiding ( ($), (.) )

Das erkläre ich gleich, muss aber ganz am Anfang der Datei stehen...


----------------------------------------------------------------------
Zu Aufgabe 1:  Programmieren mit Funktionen


> fib :: Integer -> Integer
> 
> fib 0 = 0
> fib 1 = 1
> fib n = fib (n-1) + fib (n-2)

Im “funktionalen Stil” programmiert man eher mit dem Zusammensetzen
von Funktionen.

Wie sieht das aus?

Arbeite auf Paaren von aufeinander folgenden Fibonacci-Zahlen und
berechne aus einem Paar (x,y) das darauf folgende Paar (y,x+y):

> nextfib :: (Integer,Integer) -> (Integer,Integer)
> nextfib (x,y) = (y,x+y)

Diese Funktion müssen wir “iterieren”, d.h. immer wieder auf ihr
letztes Ergebnis anwenden.  Wie?

Dafür gibt es bereits eine Funktion `iterate` (vgl. Vorlesung)

    :t iterate

Wieso sind da Klammern im Typ?    

  * `iterate` konsumiert eine Funktion als erstes Argument

  * Vergleiche mit Funktion `ggt` vom letzten Mal:

> ggt :: Integer -> Integer -> Integer
> ggt m 0 = m
> ggt m n = ggt n (m `mod` n)

    also eigentlich

      ggt :: Integer -> (Integer -> Integer)

  * Currying:

      :t ggt 4

Wie könnte man `iterate` konstruieren?

> iterate' :: (a -> a) -> a -> [a]
> iterate' f x = x : iterate' f (f x)

Die Funktion `f` wird immer nur weitergereicht.  Diesen Code kann man
lesbarer gestalten:

> iterate'' :: (a -> a) -> a -> [a]
> iterate'' f x = go x
>   where
>     go x = x : go (f x)

Hier greift die lokal definierte Funktion `go` immer auf das gleiche
`f` zu, welches als Argument an `iterate''` übergeben wurde.

Wenn man Currying konsequent weiter denkt, dann geht auch dies:

> iterate''' :: (a -> a) -> a -> [a]
> iterate''' f = go
>   where
>     go x = x : go (f x)

Was hat sich geändert?  Nächste Woche besprechen wir diese
η-Konversion genauer...



Zurück zu den Fibonacci-Zahlen:

Können wir `iterate` auf `nextfib anwenden?  Was erwarten Sie hier?

    :t iterate nextfib

Auch hier beobachten wir Currying.  Außerdem wird die Typvariable `a`
auf `Integer` festgelegt.

Versuchen wir das mal mit einem Startwert:

    iterate nextfib (0,1)    

Offenbar bekommen wir alle Paare ausgegeben.  Wie können wir das
abbrechen?

  * In der Vorlesung ist uns `take` begegnet

        :t take

    Was tut das?

    `take n` gibt die ersten n Elemente einer Liste aus.

  * Wie können wir `take` hier benutzen?

        take 10 (iterate nextfib (0,1))

  * Analog zu `take` gibt es `drop`:

        :t drop

    Was macht das?

    `drop n` wirft die ersten n Elemente einer Liste weg.

  * Was passiert hier:

        take 10 (drop 10 (iterate nextfib (0,1)))

  * Und dann gibt es noch `head` und `tail`, die das erste Element
    einer Liste, bzw. die Restliste zurückgeben.

        head [1..1000000000000000000000000000000000000000]
        tail [1,2,3,4,5]

        :t head
        :t tail        

    Was passiert hier:

        head (drop 10 (iterate nextfib (0,1)))


  * Vergleiche mit `fib 10`, was müssen wir noch tun um die 10
    Fibonacci-Zahl zu bekommen?

    Das erste Element aus dem Paar holen:

        :t fst

    Also:

        fst (head (drop 10 (iterate nextfib (0,1))))

Damit können wir noch eine Variante von `fib` bauen:

> fib'' n = fst (head (drop n (iterate nextfib (0,1))))

Beobachtungen: Offenbar bauen wir Funktionen zusammen, indem wir sie

  * Aufeinander anwenden:  `iterate nextfib`

  * Nacheinander ausführen:  `... (... (... (...)))`               

Klammeritis?  Man kann sich einen Haufen Klammern sparen, indem man
zwei Operatoren einführt:


- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
Applikation


Frage: Geben Sie einen λ-Ausdruck APPLY an, der sein erstes Argument
       auf sein zweites anwendet:

    APPLY f x  →  f x

    APPLY = ???

    APPLY = λf x. f x

Diesen Operator nennen wir `$`, vereinbaren rechts-Assoziativität, und
geben ihm die *niedrigste* Priorität:

> ($) :: (a -> b) -> a -> b
> infixr 0 $
> 
> f $ x = f x

Beispiele zur Applikation `$`:
  
    sqrt 42
    sqrt $ 42

    sqrt 7 + 2
    sqrt $ 7 + 2

Was ist da passiert?

  * Erinnerung: `$` bindet schwächer als `+`.

Was ist mit

    sqrt $ sqrt $ 81

Offenbar ist `$` rechtsassoziativ!

    Rechtsassoziativ heißt:  f $ g $ x  ≡  f $ (g $ x)

Welches der beiden `$` in

    sqrt $ sqrt $ 81

kann ich weglassen?  Und wieso?

    sqrt $ sqrt 81

Juxtaposition bindet stärker als alle Infix-Operatoren!

Damit lässt sich `fib` ein weiteres Mal neu formulieren:

> fib3 n = fst $ head $ drop n $ iterate nextfib (0,1)


- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
Komposition


Frage: Geben Sie einen λ-Ausdruck COMPOSE an, der die Komposition der
       beiden übergebenen Funktionen berechnet:

    COMPOSE f g  →  f ∘ g

    COMPOSE = ???


Das kann man sich schrittweise überlegen:

    (COMPOSE f g) x = f (g x)
                                -- Applikation ist linksassoziativ
    COMPOSE f g x = f (g x)
                                -- Argumente nach rechts holen
    COMPOSE f g = λx. f (g x)   

    COMPOSE f = λg x. f (g x)

    COMPOSE = λf g x. f (g x)
  
Diesen Operator nennen wir `.`, vereinbaren rechts-Assoziativität, und
geben ihm die *höchste* Priorität (nach der Juxtaposition):

> infixr 9 .
> (.) :: (b -> c) -> (a -> b) -> a -> c
> 
> f . g = \x -> f (g x)

    ^-- Leerzeichen um den Punkt machen!  Haskell interpretiert den
        Punkt sonst in manchen Fällen anders.

Nochmal der Vergleich mit Schulwissen:

     Schule:   (f ∘ g)(x)  ≡  f(g(x))

    Haskell:   (f . g) x   ≡  f (g x)

Die Komposition erzeugt eine neue Funktion!

    :t div 100
    :t ggt 10
    
    :t div 100 . ggt 10

Was kommt hier raus?

    div 100 . ggt 10 $ 8

Die vierte Variante von `fib`

> fib4 n = fst . head . drop n $ iterate nextfib (0,1)

oder (wieder etwas länger):

> fib5 n = fst . head . drop n . iterate nextfib $ (0,1)

  * Kann man das letzte `$` durch `.` ersetzen?

  * Wieso nicht?



Zusammenfassung:

  * Der Applikations-Operator `$` wendet sein linkes Argument auf das
    rechte an.

  * Der Kompositions-Operator `.` ist die übliche
    Funktionskomposition `∘`.



Beide Funktionen sind bereits vordefiniert

    Prelude> :i $ .
    ($) :: (a -> b) -> a -> b       -- Defined in ‘GHC.Base’
    infixr 0 $
    (.) :: (b -> c) -> (a -> b) -> a -> c   -- Defined in ‘GHC.Base’
    infixr 9 .

  * Eine Haskell-Datei definiert ein “Modul”, also eine Sammlung von
    Funktionen (ähnlich einer Bibliothek).

  * Das Standard-Modul `Prelude` wird immer automatisch eingebunden
    und stellt viele Funktionen bereit, unter anderem `.` und `$`.

    Obacht: Sie dürfen vordefinierte Funktionen zur Lösung der Übungen
            nur dann verwenden, wenn sie in der Vorlesung besprochen
            wurden!

  * Damit ich diese Funktionen neu definieren kann, muss ich dem GHCi
    sagen, dass er sie beim Einbinden der `Prelude` verstecken soll.
    Das passiert in der Zeile

        import Prelude hiding ( ($), (.) )

    ganz oben in dieser Datei.



    * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
    *                                                               *
    *  Verwenden Sie `$` und `.` um Ihren Code lesbarer zu machen!  *
    *                                                               *
    *  Lernen Sie Code mit `$` und `.` zu lesen!                    *
    *                                                               *
    * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *


- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
Anmerkung zu `Int` und `Integer`:


Funktionen wie z.B. `take` und `drop` sind auf `Int` definiert:

    take :: Int -> [a] -> [a]
    drop :: Int -> [a] -> [a]

Wir hatten zwar für `fib :: Integer -> Integer` den Typ angegeben,
aber nicht für `fib''` bis `fib5`.  Deren Typ ist tatsächlich jeweils

    Int -> Integer

weil sie die Funktion `drop` verwenden.

    :t drop

`drop` (und `take`) verwenden `Int` weil Listen selten mehr als 2^63
Einträge haben, und sich auf den kompakteren `Int`s schneller rechnen
lässt.

Diese Definition liefert dann auch den erwarteten Typfehler:

 > fib4' :: Integer -> Integer
 > fib4' n = fst . head . drop n $ iterate nextfib (0,1)

    Couldn't match expected type ‘Int’ with actual type ‘Integer’
    In the first argument of ‘drop’, namely ‘n’
    In the second argument of ‘(.)’, namely ‘drop n’

Hier können wir uns mit expliziter Umwandlung des Typs behelfen:

    fromIntegral :: (Integral a, Num b) => a -> b

Die Funktion `fromIntegral` akzeptiert insbesondere Werte der Typen
`Int` und `Integer`, und konvertiert in einen passenden numerischen
Wert:

> fib6 :: Integer -> Integer
> fib6 n = fst . head . drop (fromIntegral n) $ iterate nextfib (0,1)

Mehr dazu später, im Kapitel über Typklassen.


----------------------------------------------------------------------
Zu Aufgabe 4


and = λx y. if x y False

> (&&&) :: Bool -> Bool -> Bool
> x &&& y = if x then y else False       -- Haskell kennt bereits `&&`


or = λx. λy. if x True y

> (|||) :: Bool -> Bool -> Bool
> x ||| y = if x then True else y        -- Haskell kennt bereits `||`


not = λx. if x False True

> not' x = if x then False else True    -- Haskell kennt bereits `not`


- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
Striktness


In der Logik gilt ja

    a ∧ b  ≡  b ∧ a

Unsere Definition von `&&&` zeigt diese Symmetrie nicht.

    x &&& y = if x then y else False

           ≡? if y then x else False

Offensichtliche Fragen:  Bedeutet das was?  Was bedeutet das?



Definition:

    Eine Funktion `f` heißt “strikt” genau dann, wenn

        f ⊥  →  ⊥

  * Das Symbol `⊥` steht für “undefiniert” (auch “bottom”).

  * Sehr vage formuliert: `f` kann nichts liefern, ohne sich sein
    Argument anzugucken.



Bottom `⊥` kann *prinzipiell nicht* von einer nicht-terminierenden
Berechnung unterschieden werden!

Haskell kennt

    undefined :: α
    error :: String → α

deren Auswertung führt immer zum Abbruch der Berechnung, aus Sicht des
Haskell-Programmes verhalten sie sich also wie ⊥.

    not'         ist strikt
    (&&&)        ist strikt
    (False &&&)  ist nicht strikt

Frage: Kann man `&&&` so schreiben, dass es einfach überprüft welches
       Argument definiert ist?

       Nein.  ⊥ ist (aus Sicht des Programmes) das gleiche wie eine
       nicht-terminierende Berechnung.


----------------------------------------------------------------------
Zu Aufgabe 5

> between :: Integer -> Integer -> Integer -> Bool
> between l r x = if l < x then x < r else r < x && x /= l

> between' :: Integer -> Integer -> Integer -> Bool
> between' l r x = signum (l-x) == signum (x-r) && l/=r

Beachte daß der Typ für beide Funktionen nicht explizit angegeben ist.
Haskell ermittelt selbst die passenden Typen (Typ Inferenz, später in
der Vorlesung), aber man kann jetzt schon einen Unterschied zwischen
`between` und `between'` sehen:

    :t between
    :t between'

Vergleiche mit

    :t (<)
    :t signum
    :t (==)

Es gibt also numerische Typen, vergleichbare Typen, und anordenbare
Typen.  `Integer` hat alle drei Eigenschaften:

    :i Integer

Mehr dazu später im Kapitel zu Typklassen.


======================================================================
