
Konzepte der Programmierung                       Universität Konstanz
Programmierkurs 2                Informatik & Informationswissenschaft
Sommer 2016                                Marc Scholl, Stefan Klinger

======================================================================

                             30. Mai 2016

----------------------------------------------------------------------

> import Prelude hiding ( all, and, maximum )

----------------------------------------------------------------------
Organisatorisches


Prüfungsanmeldung:

  * Für KdP *und* PK2 im StudIS verbindlich zur Prüfung anmelden!

  * Melden Sie sich für *beide* Veranstaltungen an, auch wenn Sie die
    Klausurzulassung aus früherem Semester haben.

  * Es findet nur eine gemeinsame KdP-Klausur statt.

  
----------------------------------------------------------------------
zu Aufgabe 2, spur


Testmatrizen:

> mat :: Integer -> Integer -> [[Integer]]
> 
> mat m n = [ [a .. a + n - 1] | a <- [1..m] ]

Testen:

    mat 7 3
    mat 3 7



> and :: [Bool] -> Bool
> 
> and = foldr (&&) True

Was tut diese Funktion?

  * Berechnet die Konjunktion aller Listenelemente.


> all :: (a -> Bool) -> [a] -> Bool
> 
> all p = and . map p

Was tut diese Funktion?

  * Prüft ob alle Listeneinträge ein Prädikat erfüllen.


Was tut diese Funktion?

> isSquare :: [[a]] -> Bool
>
> isSquare m = all (== length m) (map length m)

  * Prüft ob die Matrix quadretisch ist.



Übrigens: Die Funktionen `and`, `or` und `all` sind schon in der
          `Prelude` enthalten.



Damit könnte man `allEqual` auch so implementieren (cf. `pk2-06.lhs`):

> allEqual :: [Integer] -> Bool
> 
> allEqual [] = True
> allEqual (x:xs) = all (==x) xs

Testen:

    allEqual [ x `mod` 2 | x <- [0,2..100] ]
    allEqual [1..10000000]


----------------------------------------------------------------------
Zu Aufgabe 1, maxCollatz


Die Funktion vom Übungsblatt:

> f :: Integer -> Integer
> f x | m==0 = d
>     | otherwise = 3*x + 1
>     where
>     (d,m) = divMod x 2

Aus den Tutorien:

> steps :: Integer -> Integer
> steps 1 = 0
> steps x = 1 + steps (f x)

> maxSteps :: (Integer, Integer) -> Integer -> (Integer, Integer)
> maxSteps top 0 = top
> maxSteps top n = maxSteps (max top (steps n, n)) (n-1)

> maxCollatz = maxSteps (-1,0) 500



Noch "funktionaler":

> steps' = length . takeWhile (/= 1) . iterate f

Erklärung?

  1. Wende `f` iterativ immer wieder an.

  2. Kürze die Liste der Ergebnisse, sobald eine `1` auftaucht.

  3. Bestimme die Länge der Liste.


Obacht:

    length :: [a] -> Int

Damit liefert `steps'` einen `Int` statt einem `Integer`.

Wie könnte man das fixen?

    toInteger :: Integral a => a -> Integer

> steps'' :: Integer -> Integer
> steps'' = toInteger . length . takeWhile (/= 1) . iterate f

Das bringt hier aber nicht viel, weil wir uns im Bereich kleiner
Zahlen bewegen.



Frage: Wenn `steps' n` die Anzahl der Schritte von `n` bis 1 liefert,
       wie kriegen wir die jeweilige Anzahl für alle Zahlen bis
       sagen wir mal 20?

    map steps' [1..20]

    [ steps' x | x <- [1..20] ]

Typ von `map`?



Schön.  Aber wir wollen dazu noch die jeweilige Zahl `n` haben.  Wie?

    map (\x -> (steps' x, x)) [1..20]

    [ (steps' x, x) | x <- [1..20] ]

    (\xs -> zip (map steps' xs) xs) [1..20]

Typ von `zip`?



Der Ausdruck `extreme max xs` soll das `max`imale Element in `xs`
liefern:

> extreme :: (a -> a -> a) -> [a] -> a

> extreme _ [] = error "extreme: empty list"

 > extreme _ [x] = x
 > extreme max (x:xs) = x `max` extreme max xs

    extreme min "hello world"
    extreme max "hello world"

Wie kann man `extreme` eleganter schreiben?
 
 > extreme max xs = go xs
 >   where
 >     go [x] = x
 >     go (x:xs) = x `max` go xs


Das nächste geht leider nicht:

 > extreme max = go
 >   where
 >     go [x] = x
 >     go (x:xs) = x `max` go xs

Weil: Alle Definitionszweige einer Funktion müssen mit gleich vielen
      Argumenten ausgestattet sein (der Grund dafür liegt in den
      Tiefen des Compilers).

Aber das geht:

> extreme max (x:xs) = foldr max x xs



Die Funktion `maximum` bestimmt das Maximum aus einer Liste, sie ist
in der Prelude bereits vordefiniert.

    maximum :: Ord a => [a] -> a

    extreme max :: Ord a => [a] -> a

Woher kommt das `Ord a`?

    max :: Ord a => a -> a -> a
    extreme :: (a -> a -> a) -> [a] -> a

Der “type constraint” (Folie 311) überträgt sich auf die
zusammengesetzte Funktion.

Übrigens: Bei folgender Funktion leitet der GHCi nicht den
allgemeinsten Typ ab, obwohl das bei interaktiver Eingabe
funktioniert:



> maximum :: Ord a => [a] -> a    -- ohne diese Zeile geht's nicht

> maximum = extreme max

=> Geben Sie immer den Typ an!

> foo = maximum "blah"


Damit bestimmen wir das größte Paar aus unserer Liste:

> maxSteps' :: Integer -> (Int, Integer)
> 
> maxSteps' n = maximum [ (steps' x, x) | x <- [1..n] ]


> maxCollatz' :: (Int, Integer)
> 
> maxCollatz' = maxSteps' 500



----------------------------------------------------------------------
zu Aufgabe 4, Assoziativgesetz


Folgendes ist allenfalls ein (nicht falsches) Argument, aber kein
Beweis:

    Seien x1 = [a1..an], x2 = [b1..bn], x3 = [c1..cn].

    Laut Definition ist

        (x1++x2)++x3
      =
        (a1 : a2 : ... : an : x2) ++ x3
      =
        a1 : ... : an : b1 : ... : bn : x3
      =
        [a1, ..., an, b1, ..., bn, c1, ... cn]


  * Ellipsen `...`, auch “Auslassungszeichen” gelten nicht als formaler
    Beweis, sondern Auslassung des Beweises.

Ausserdem:

  * Alle drei Listen sind gleich lang, die Indizes gehen immer von 1
    bis n.

  * Was ist wenn eine/mehrere der drei Listen nicht terminieren?  Die
    Aussage macht ja trotzdem Sinn:

        take 10 $ "foo" ++ ("bar" ++ ['a'..])
      =
        take 10 $ ("foo" ++ "bar") ++ ['a'..]



Gefahr bei Ellipsen                                 (gefunden bei [1])
-------------------

“Beweisen” für alle natürlichen Zahlen n die Aussage:

    1^2 + 2^2 + 3^2 + ... + n^2  =  n * (n + 1) * (2 * n + 1) / 6

IA: n = 0

  links:   leere Summe ist 0
      
  rechts:  n*(n+1)*(2*n+1)/6 = 0*(0+1)*(2*0+1)/6 = 0
      
IH: Für ein beliebiges festes n gelte

    1^2 + 2^2 + 3^2 + ... + n^2  =  n * (n + 1) * (2 * n + 1) / 6

IS: Schritt von n zu n+1.  Addiere  2*n + 1  auf beiden Seiten der IH:

  links:
  
      1^2 + 2^2 + 3^2 + ... + n^2 + 2*n + 1
    =                                                           (☠)
      1^2 + 2^2 + 3^2 + ... + (n + 1)^2


    Hier sieht man den Fehler:
      1^2 + 2^2 + 3^2 + ... + (n-1)^2 + n^2 + 2*n + 1
    = 
      1^2 + 2^2 + 3^2 + ... + (n-1)^2 + (n + 1)^2

  rechts:
  
      n * (n + 1) * (2 * n + 1)
      ------------------------- + 2 * n + 1
                  6           
    =
      n * (n + 1) * (2 * n + 1) + 12 * n + 6
      --------------------------------------
                        6
                         
  =      Arithmetik                                             (☠)
    
      (n + 1) * (n + 2) * (2 * n + 3)
      -------------------------------
                    6

    =      Die (n+1)-Terme ausrechnen
    
      (n+1) * ((n+1) + 1) * (2 * (n+1) + 1)
      --------------------------------------
                        6

Fehler in den mit (☠) gekennzeichneten Zeilen.  Wo?


Stolperfalle: “Das ist doch klar dass das so ist, das muss der Tutor
               doch sehen!”

Beim Beweisen geht es (in Übung und Klausur) nicht darum uns die
Aussage zu beweisen, sondern die notwendigen Beweistechniken zu
erlernen, zu üben und zu demonstrieren.


----------------------------------------------------------------------
Bestimmung der freien/gebundenen Variablen


Struktur der λ-Ausdrücke:

    Expr ::= Var                          Variablen
          |  Expr Expr                    Applikation
          |  `λ` Var `.` Expr             λ-Abstraktion

(Struktur?  Vgl. KdP, Folie 41)

    $ zathura -P 19 ../pub/lecture02.pdf&



Entwerfen die Funktion `free`, die die freien Variablen eines
λ-Ausdrucks bestimmt:

    Seien  v ∈ Var, e ∈ Expr .

    free ⟦ v ⟧       =   {v}

    free ⟦ e1 e2 ⟧   =   free ⟦e1⟧ ∪ free ⟦e2⟧

    free ⟦ λv. e ⟧   =   free ⟦e⟧ ∖ {v}


Obacht: Die Funktion `free` ist hier *nicht* im λ-Kalkül definiert.
        Statt dessen operiert sie *auf* Ausdrücken des λ-Kalküls.
        Diese Meta-Ebene wird mit den semantischen Klammern ⟦·⟧
        angedeutet.


Beispiel 1:

      free ⟦ λx. x y ⟧
    =
      free ⟦ x y ⟧ ∖ {x}
    =
      (free ⟦x⟧ ∪ free ⟦y⟧) ∖ {x}
    =
      ({x} ∪ {y}) ∖ {x}
    =
      {x, y} ∖ {x}
    =
      {y}


Beispiel 2:

      free ⟦ (λx. x x) (λy. + y z) ⟧
    =
      free ⟦ λx. x x ⟧ ∪ free ⟦ λy. + y z ⟧
    =
      (free ⟦ x x ⟧ ∖ {x}) ∪ (free ⟦ + y z ⟧ ∖ {y})
    =
      ((free ⟦x⟧ ∪ free ⟦x⟧) ∖ {x}) ∪ ((free ⟦+ y⟧ ∪ free ⟦z⟧) ∖ {y})
    =
      (({x} ∪ {x}) ∖ {x}) ∪ ((free ⟦+⟧ ∪ free ⟦y⟧ ∪ {z}) ∖ {y})
    =
      (({x} ∪ {x}) ∖ {x}) ∪ ({+} ∪ {y} ∪ {z}) ∖ {y})
    =
      ({x} ∖ {x}) ∪ ({+,y,z} ∖ {y})
    =
      ø ∪ {+,z}
    =
      {+,z}



Nochmal die Struktur:

    Expr ::= Var                          Variablen
          |  Expr Expr                    Applikation
          |  `λ` Var `.` Expr             λ-Abstraktion

Das sieht doch so ähnlich aus wie ein algebraischer Datentyp!

> data LExpr
>     = Var String         -- Variable
>     | App LExpr LExpr    -- Funktionsapplikation
>     | Lam String LExpr   -- Lambda-Abstraktion  
>     deriving (Eq, Show)                         


Beispiel 1:  λx. x y

> bsp1 = Lam "x" $ Var "x" `App` Var "y"


Beispiel 2:  (λx. x x) (λy. + y z)

> bsp2 = (Lam "x" $ Var "x" `App` Var "x")
>        `App`
>        (Lam "y" $ Var "+" `App` Var "y" `App` Var "z")


Wie können wir die Funktion `free` in Haskell implementieren?  Verwende
Listen statt Mengen.

    free ⟦ v ⟧       =   {v}
    free ⟦ e1 e2 ⟧   =   free ⟦e1⟧ ∪ free ⟦e2⟧
    free ⟦ λv. e ⟧   =   free ⟦e⟧ ∖ {v}


> free :: LExpr -> [String]
> 
> free (Var v) = [v]
> free (App e e') = free e ++ free e'
> free (Lam v e) = filter (/= v) $ free e


Frage: Definiere eine Funktion `bindings`, die für einen λ-Ausdruck
       die Menge seiner Variablenbindungen bestimmt:

    bindings ⟦ v ⟧      =  ø

    bindings ⟦ λv. e ⟧  =  {v}  ∪  bindings ⟦e⟧

    bindings ⟦ e1 e2 ⟧  =  bindings ⟦e1⟧  ∪  bindings ⟦e2⟧

Obacht: Diese Funktion gibt *nicht* die gebundenen Variablen aus,
        sondern die Bindungen:

             bindings ⟦ λx.y ⟧ = {x}

         anstatt `ø`.


> bindings :: LExpr -> [String]
> 
> bindings (Var _) = []
> bindings (App e1 e2) = bindings e1 ++ bindings e2
> bindings (Lam v e) = v : bindings e


Anwendung:

Die Anwendung von β-Reduktion auf einen Ausdruck `e1 e2` ist “sicher”
(d.h., keine α-Konversion ist notwendig), wenn gilt

    bindings e1  ∩  free e2  =  ø

> safe :: LExpr -> LExpr -> Bool
> 
> safe e1 e2 = null [ v | v <- bindings e1, v `elem` free e2 ]

Ausprobieren:

    (λx y. x) (g y)
    safe (Lam "x" . Lam "y" $ Var "x") (Var "g" `App` Var "y")

    (λx y. x) (λy. g y)
    safe (Lam "x" . Lam "y" $ Var "x") ( Lam "y" $ Var "g" `App` Var "y")



Übrigens: Diese Bedingung ist *hinreichend* aber *nicht* notwendig.

  * Wieso?

  * Was heisst das überhaupt, hinreichend/notwendig?


Beispiel:

    (λx. f x) (g x)
    safe (Lam "x" $ Var "f" `App` Var "x") (Var "g" `App` Var "x")

Aber:

       (λx. f x) (g x)
    β→
       (f x)[x ← g x]
     =                          — keine α-Konversion nötig!
       f (g x)
    
----------------------------------------------------------------------

[1] http://www.math.vanderbilt.edu/~schectex/commerrs/#Ellipsis

======================================================================
