
Konzepte der Programmierung                       Universität Konstanz
Programmierkurs 2                Informatik & Informationswissenschaft
Sommer 2016                                Marc Scholl, Stefan Klinger

======================================================================

                            13. Juni 2016

----------------------------------------------------------------------

> import qualified Data.Set as S
> import Data.Set ( (\\) )
 
----------------------------------------------------------------------
Organisatorisches


  * Am Mo, 20. Juni 2016, lasse ich mich durch Leonard Wörteler
    vertreten.  Keine Terminänderung.

  * Am Di, 21. Juni 2016, tauscht Marc Scholl seine Do-Vorlesung mit
    mir, d.h. es finden statt

      DBS am Di, 21. Juni, 15:15 in A701, und

      KdP am Do, 23. Juni, 11:45 in M629.

  * Am Mo, 27. Juni 2016, tauscht Marc Scholl seine Di-Vorlesung mit
    mir, d.h. es finden statt

      DBS am Mo, 27. Juni, 15:15 in R513, und

      PK2 am Di, 28. Juni, 11:45 in M629.

Also jeweils wieder wieder gleicher Raum zur gleichen Zeit, nur mit
anderem Inhalt.


----------------------------------------------------------------------
zur Fehlersuche (z.B. Aufgabe 2)


Liefert einen Fehler:

 > getLeft :: [Either a b] -> [a]
 > getLeft = foldr (either (:) id) []

⇒ Kein Punkte!  Besser auskommentieren, und genau erklären was man tut
                (oder zu tun versucht).



Noch besser: Statt Auskommentieren `undefined` verwenden.

    undefined :: τ

`undefined` kann jeden beliebigen Typ annehmen.  Man kann's nur nicht
auswerten:

    :t undefined < 3

Also:

 > getLeft :: [Either a b] -> [a]
 > getLeft = foldr (either (:) undefined) []

    getLeft [Left 1, Left 2, Right True]

Immerhin bekommt man schon teilweise ein Ergebnis.

Und dazu einen Kommentar wie diesen:

    Auf `Left`-Werte in der Eingabeliste wird `:` angewendet um sie an
    das bereits bestehende Ergebnis (initial `[]`) vorne anzufügen.

    Für `Right`-Werte wollen wir das bisher berechnete Ergebnis in
    Ruhe lassen.  Eigentlich sollte da `id` statt `undefined` stehen,
    aber das funktioniert nicht.  Wieso?

Dafür gibt's mehr Punkte als für die auskommentierte Version oben:
Hier steht was der Plan ist, und der Tutor sieht am `undefined` genau
wo Sie nicht weitergekommen sind!



Typed Holes:   

Ab Version 7.8 erlaubt Ihnen der GHC “Löcher” einzubauen, und versucht
dann zu erraten was für einen Typ das Loch haben muss.

  * Das liefert eine Fehlermeldung (⇒ keine Punkte), also vor der
    Abgabe besser `undefined` hinschreiben!

  * Ein “Hole” ist eine freie Variable die mit `_` anfängt (oder nur
    daraus besteht):

 > getLeft :: [Either a b] -> [a]
 > getLeft = foldr (either (:) __ ) []

    Der GHCi jammert:

    pk2-09.lhs:126:31: error:
        • Found hole: ___ :: b -> [a] -> [a]
          Where: ‘a’ is a rigid type variable bound by
                   the type signature for:
                     getLeft :: forall a b. [Either a b] -> [a]
                   at pk2-09.lhs:125:14
                 ‘b’ is a rigid type variable bound by
                   the type signature for:
                     getLeft :: forall a b. [Either a b] -> [a]
                   at pk2-09.lhs:125:14
          Or perhaps ‘___’ is mis-spelled, or not in scope

Brauchen also eine Funktion mit Typ β → [α] → [α].  Wie könnte die
aussehen?

    \x ys -> ys

    flip const

    const id       



Jetzt:

> getLeft :: [Either a b] -> [a]
> getLeft = foldr (either (:) $ const id) []

   

Tutorial zu “Typed Holes”:

    Mark Wotton.  Typed Holes for beginners.
    http://www.shimweasel.com/2015/02/17/typed-holes-for-beginners


----------------------------------------------------------------------
Zu Aufgabe 3, `LExpr` und `bound`

 
> data LExpr
>     = Var String         -- Variable
>     | App LExpr LExpr    -- Funktionsapplikation
>     | Lam String LExpr   -- Lambda-Abstraktion
>     deriving (Eq, Show)


Zum Testen:

> e1 = (Lam "x" $ (Lam "y" $ Var "*" `App` Var "x" `App` Var "x")
>                 `App`
>                 (Var "y"))
>      `App`
>      Var "y"



Eleganter wären Lösungen für `free`, `bound`, etc., die tatsächlich
auf Mengen basiert, statt auf Listen.
            
Das Modul `Data.Set` [1] stellt eine Implementation von Mengen zur
Verfügung.

Module können mit dem `import`-Statement im Kopf des Quellcodes
eingebunden werden [2].

    import Data.Set

Jetzt können alle alle von `Data.Set` exportierten funktionen
verwendet werden, z.B.

    fromList :: Ord a => [a] -> Set a

 > set :: Set Integer
 > set = fromList [ x `mod` 7 | x <- [1..100] ]

Mengen implementieren `show` für geeignete Elementtypen:

    instance Show a => Show (Set a)

Testen:

    set



Allerdings:

    `Data.Set` definiert:
    
        filter :: (a -> Bool) -> Set a -> Set a
      
    `Prelude` definiert:

        filter :: (a -> Bool) -> [a] -> [a]

    Welches `filter` ist gemeint?

 > f1 = filter (<3) set   -- ☠ Konflikt!

 > f1 = Data.Set.filter (<3) set   -- Viel Tipparbeit
 > f2 = Prelude.filter (<3) [0..10]
                
Um Konflikte zu vermeiden, sollte man “qualifiziert” importieren:

    import qualified Data.Set

Jetzt gibt es zwar `Data.Set.filter`, aber nur ein `filter`:

 > set :: Data.Set.Set Integer
 > set = Data.Set.fromList [ x `mod` 7 | x <- [1..100] ]

 > f1 = filter (<3) [0..10]           -- Prelude.filter
 > f2 = Data.Set.filter (<3) set     -- Data.Set.filter

Damit man weniger schreiben muss, kann man den Namespace-Prefix selber
definieren:

    import qualified Data.Set as S

Jetzt:

> set :: S.Set Integer
> set = S.fromList [ x `mod` 7 | x <- [1..100] ]

> f1 = filter (<3) [0..10]   -- Prelude.filter
> f2 = S.filter (<3) set    -- Data.Set.filter

Unangenehm ist noch dass wir auch Infix-Operatoren mit dem
Namespace-Prefix `S.` versehen müssen.

    set  S.\\  S.singleton 3

Deswegen importiren wir zusätzlich noch `\\` ohne Präfix:

    import qualified Data.Set as S
    import Data.Set ((\\))

    set \\ S.singleton 3


Obacht: Lösungen zu den Aufgaben sollen selbstverständlich
        eigenständig programmiert werden.  Verwenden Sie nur
        Funktionen und Module die wir bereits besprochen haben.



Also: Verwenden Mengen für die freien/gebundenen Variablen.

> free :: LExpr -> S.Set String
>
> free (Var v)    = S.singleton v             -- {v}
> free (App e e') = free e `S.union` free e'  -- free e ∪ free e'
> free (Lam v e)  = S.delete v $ free e       -- free e ∖ {v}


> bound :: LExpr -> S.Set String
>
> bound (Var _)
>   = S.empty                       -- ∅
>   
> bound (App e1 e2)
>   = bound e1 `S.union` bound e2   -- bound e1 ∪ bound e2
>   
> bound (Lam v e)
>   | S.member v $ free e           -- v ∈ free e
>       = S.insert v $ bound e      -- {v} ∪ bound e
>   | otherwise
>       = bound e
 
Was ist hier noch unschön?



Für jede Bindung `λv.e` sucht `bound` nach freien Variablen in `e`, um
zu prüfen ob `v` dort überhaupt vorkommt.

Besser: Sammle beim Abstieg alle *Bindungen* auf.  Erst wenn eine der
gebundenen Variablen tatsächlich auftaucht, wird sie zum Ergebnis
hinzugefügt:

> bound' :: LExpr -> S.Set String

> bound' = go S.empty  -- ∅ = bekannte Bindungen
>   where
>     go bs (Var v)

        Gab es im Baum darüber es eine Bindung `λv`?  v ∈ bs ?

>       | v `S.member` bs = S.singleton v
>       | otherwise       = S.empty

>     go bs (App e1 e2)
>       = go bs e1 `S.union` go bs e2    -- bound e1 ∪ bound e2

>     go bs (Lam v e)             
>       = go (S.insert v bs) e


----------------------------------------------------------------------
zu Aufgabe 4, `telem`, `tmax`


Bekannt sind:

> data BinTree a
>     = Empty
>     | Node (BinTree a) a (BinTree a)
>     deriving Eq

> tfold :: (b -> a -> b -> b) -> b -> BinTree a -> b
> tfold f z Empty = z                                       -- tfold.1
> tfold f z (Node l a r) = f (tfold f z l) a (tfold f z r)  -- tfold.2

> leaf :: a -> BinTree a
> leaf x = Node Empty x Empty

> t = Node
>     (Node Empty 1 (leaf 0))
>     2
>     (Node (Node (leaf 3) 4 Empty) 6 (leaf 7))

> instance Show a => Show (BinTree a) where
>     showsPrec _ = foldl (.) id . ppt
>         where
>         ppt :: Show a => BinTree a -> [ShowS]
>         ppt Empty = [showString "@\n"]
>         ppt (Node l x r)
>             = shows x . showString "\n"
>               :
>               indent "|--" "|  " (ppt l)
>               ++
>               indent "`--" "   " (ppt r)
>         indent :: String -> String -> [ShowS] -> [ShowS]
>         indent i1 i2 (x:xs)
>             = showString i1 . x : map ((showString i2) .) xs



Aus den Tutorien:

> telem :: Integer -> BinTree Integer -> Bool
> telem x = tfold (\il v ir -> x==v || il || ir) False

> tmax :: BinTree Integer -> Maybe Integer
> tmax = tfold (\ml v mr -> maximum [ml, Just v, mr]) Nothing


Aus der Vorlesung:

> inorder Empty = []
> inorder (Node l a r) = inorder l ++ a : inorder r

oder mit `tfold`:

> inorder' :: BinTree a -> [a]
> inorder' = tfold (\ls a rs -> ls ++ a : rs) []



Man könnte `telem` und `tmax` auf Listen zurückführen:

> telem' :: Integer -> BinTree Integer -> Bool
> telem' x = elem x . inorder'

> safeMaximum :: Ord a => [a] -> Maybe a
> safeMaximum [] = Nothing
> safeMaximum l = Just $ maximum l

> tmax' :: BinTree Integer -> Maybe Integer
> tmax' = safeMaximum . inorder'


Aber:

> leftist :: [a] -> BinTree a
> leftist []     = Empty
> leftist (x:xs) = Node (leftist xs) x Empty

Testen:

    tmax' $ leftist [1..10000]

Warum?

Antwort: Die Listenkonkatenation `++` in `inorder` ist teuer!

Also verbessern wir `inorder` — Wie?



Plan A:  Akkumulierender Parameter
----------------------------------

> inorder'' :: BinTree a -> [a]
> inorder'' = go []
>   where

     Wenn wir nach links in den Baum absteigen, dann merken wir uns
     das aktuellen Knotenlabel `a` und den noch zu verarztenden
     rechten Restbaum `r`.

>     go stack (Node l a r) = go ((a,r):stack) l

     Wenn wir unten anstossen, geben wir das zuletzt gespeichere
     Knotenlabel aus, und machen mit dem zugehörigen rechten
     Unterbaum weiter.

>     go ((a,r):stack) Empty = a : go stack r

     Der einzige nicht abgedeckte Fall ist `go [] Empty`, da hören
     wir auf.

>     go _ _ = []


> tmax'' :: BinTree Integer -> Maybe Integer
> tmax'' = safeMaximum . inorder''

Testen:

    tmax'' $ leftist [1..10000]


Plan B: Konkatenation wie mit `ShowS`
-------------------------------------

> inorder''' :: BinTree a -> [a]
> inorder''' t = go t []
>     where
>     go (Node l a r) = go l . (a:) . go r
>     go Empty        = id

Frage: Was genau passiert hier?

> tmax''' :: BinTree Integer -> Maybe Integer
> tmax''' = safeMaximum . inorder'''


Und wenn's schon so offensichtlich da steht:

> inorder4 :: BinTree a -> [a]
> inorder4 t = tfold (\l a r -> l . (a:) . r) id t []

Frage: Warum hat `tfold` plötzlich 4 Argumente?

> tmax4 :: BinTree Integer -> Maybe Integer
> tmax4 = safeMaximum . inorder4


----------------------------------------------------------------------
Zu Aufgabe 3, `splitleftmost`


Eine alternative Lösung zu den "Templates" aus der Musterlösung nutzt
eine Liste von Paaren als akkumulierenden Parameter, um den Baum am
Ende wieder aufzubauen.

> splitleftmost :: BinTree a -> Maybe (a, BinTree a)
> splitleftmost = go []

>   where

     Wenn der linke Unterbaum (der 2. Parameter von `go`) ein `Node`
     ist, dann müssen wir da absteigen.  Dabei merken wir uns
     aktuellen Knoten `y` und rechten Unterbaum `r`:

>     go rs (Node l x r)  = go ((x,r):rs) l

     Sonst ist `x` die linkeste Knotenbeschriftung, `r` deren rechter
     Unterbaum.

>     go ((x,r):rs) Empty = rebuild rs r

>       where
>         rebuild ((y,r):rs) t = rebuild rs (Node t y r)
>         rebuild []         t = Just (x, t)

     Nur wenn der Baum insgesamt leer ist wurden keine “rechten
     Unterbäume” aufgesammelt.

>     go [] _ = Nothing



Ist diese Funktion endrekursiv?  Ja:

  * `splitleftmost` ist nicht selbst rekursiv (d.h. ruft sich nicht
    selbst auf).

  * `go` ruft entweder `rebuild` oder sich selbst endrekursiv auf.

  * `rebuild` baut endrekursiv den Baum von unten nach oben auf und
    gibt am Ende das Paar aus linkestem Wert und Binärbaum zurück.


----------------------------------------------------------------------

[1] http://haddock.stackage.org/lts-6.1/containers-0.5.6.2/Data-Set.html
[2] http://www.haskell.org/haskellwiki/Import

======================================================================
