
Konzepte der Programmierung                       Universität Konstanz
Programmierkurs 2                Informatik & Informationswissenschaft
Sommer 2016                                Marc Scholl, Stefan Klinger

======================================================================

                            27. Juni 2016

----------------------------------------------------------------------

  * Es gibt noch ein 13. Blatt.

  * Die Datei `lecture_except_current_chapter.pdf` [1] enthält alle
    bisherigen Folien, OHNE das aktuelle Kapitel.  Sie wird regelmäßig
    (nagut, ein/zwei Mal noch) überschrieben!

[1] https://svn.uni-konstanz.de/dbis/inf2_16s/pub/lecture_except_current_chapter.pdf

----------------------------------------------------------------------

> module Main where  -- cf. unten: Programme Compilieren

> import qualified Data.Map.Strict as M
> import Data.List ( sort, intersperse )
> import Data.Char ( isSpace )  -- testet ob ein Char Leerzeichen ist

----------------------------------------------------------------------
zu Aufgabe 2, Huffman Encoding


Bekannter Code aus den Tutorien:

> data Bit = L | R
>     deriving (Eq, Show, Ord)

> data HuffTree
>     = Leaf Char
>     | HuffTree :^: HuffTree      --  :^:  ist ein infix-Konstruktor
>     deriving Eq

> instance Show HuffTree where
>   showsPrec _ = foldl (.) id . ppTree
>    where
>    ppTree :: HuffTree -> [ShowS]
>    ppTree (Leaf c)  = [shows c . showChar '\n']
>    ppTree (l :^: r) = indent "+-" "| " (ppTree l)
>                       ++
>                       indent "`-" "  " (ppTree r)
>        where
>        ls:lss = ppTree l
>        rs:rss = ppTree r
>        indent i1 i2 (x:xs)
>            = showString i1 . x : map ((showString i2) .) xs

> en = ((((Leaf 'u' :^: (Leaf '.' :^: Leaf 'y')) :^: Leaf 's') :^: Leaf 'e') :^: ((Leaf 'i' :^: Leaf 'n') :^: (Leaf 'h' :^: Leaf 'o'))) :^: ((((((((Leaf ';' :^: Leaf 'z') :^: ((Leaf 'j' :^: ((Leaf ':' :^: Leaf 'q') :^: Leaf '(')) :^: Leaf '!')) :^: Leaf '"') :^: Leaf 'p') :^: Leaf 'l') :^: Leaf 'a') :^: (((Leaf ',' :^: (Leaf 'v' :^: (Leaf '\n' :^: (Leaf '\'' :^: (Leaf 'x' :^: (Leaf ')' :^: Leaf '?')))))) :^: (Leaf 'c' :^: Leaf 'f')) :^: Leaf 't')) :^: (((Leaf 'd' :^: (Leaf 'm' :^: Leaf 'g')) :^: ((Leaf 'w' :^: (Leaf 'b' :^: (Leaf '-' :^: Leaf 'k'))) :^: Leaf 'r')) :^: Leaf ' '))

> decodeMessage root = start
>     where
>     start [] = ""
>     start xs = decode root xs
>     decode (l :^: _) (L:bits) = decode l bits
>     decode (_ :^: r) (R:bits) = decode r bits
>     decode (Leaf c) bits = c : start bits
>     decode _ [] = error "premature end"


- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -


Nachteil der gezeigten Lösungsansätze für `encodeMessage`: Für jedes
Zeichen muß der gesamte Baum durchsucht, und die Bitfolge neu
konstruiert werden.

> encodeMessage :: HuffTree -> String -> [Bit]

> encodeMessage root = concatMap encode
>     where
>     encode :: Char -> [Bit]
>     encode q
>         = maybe (error $ "bad character: "++show q) id
>           $
>           search [] root  -- starte bei Wurzel mit leerer Bitfolge
>         where
>         search bs (Leaf c) | c==q = Just $ reverse bs
>                            | otherwise = Nothing
>         search bs (l :^: r) = search (L:bs) l <|> search (R:bs) r

> infixl 3 <|>
> (<|>) :: Maybe t -> Maybe t -> Maybe t
> Nothing <|> r = r
> l       <|> _ = l



Plan II: Lookup-Table für alle Codes aufbauen, dann nur noch die
^^^^^^^^ einzelnen Zeichen in dieser Tabelle nachschlagen.
         (aka: Map, Dictionary, ...)

Lookup-Table?  Ein Suchbaum von Schlüssel-Wert-Paaren.

> data BinTree a
>     = Empty
>     | Node (BinTree a) a (BinTree a)
>     deriving Eq

> instance Show a => Show (BinTree a) where
>     showsPrec _ = foldl (.) id . ppt
>         where
>         ppt :: Show a => BinTree a -> [ShowS]
>         ppt Empty = [showString "@\n"]
>         ppt (Node l x r)
>             = shows x . showString "\n"
>               : indent "|--" "|  " (ppt l)
>               ++ indent "`--" "   " (ppt r)
>         indent :: String -> String -> [ShowS] -> [ShowS]
>         indent i1 i2 (x:xs)
>             = showString i1 . x : map ((showString i2) .) xs

Idee: Baue den Baum so auf, dass die Werte im *linken* Unterbaum eines
Knoten alle *kleiner* sind als der Wert im Knoten selbst.  Analog
größer im rechten Unterbaum:

    'd'            <- Knoten 'd'
    |--'b'            'b' < 'd'            <- Knoten 'b'
    |  |--'a'         'a' < 'd'               'a' < 'b'
    |  |  |--@
    |  |  `--@
    |  `--'c'         'c' < 'd'               'c' > 'b'
    |     |--@
    |     `--@
    `--'f'            'f' > 'd'
       |--'e'         'e' > 'd'
       |  |--@
       |  `--@
       `--@

Suchen im Baum
--------------

Auf der Suche nach einem Buchstaben weiß man also immer ob man im
rechten oder linken Unterbaum weitersuchen muss.

Wie könnte das implementiert sein?

> find :: Ord a => a -> BinTree (a,b) -> Maybe b
>
> find x = go
>   where
>     go Empty = Nothing                          -- nichts gefunden
>     go (Node l (y, v) r) = case compare x y of
>                              EQ -> Just v       -- Treffer!
>                              LT -> go l
>                              GT -> go r

    find 'e' $ table en
    find '#' $ table en



Konstruktion des Baumes
-----------------------

Naiv könnte man einen Baum so konstruieren:

     foldr (\c r -> Node Empty c r) Empty "abcdef"

     'a'
     |--@
     `--'b'
        |--@
        `--'c'
           |--@                Wieso ist das keine gute Idee?
           `--'d'
              |--@
              `--'e'
                 |--@
                 `--'f'
                    |--@
                    `--@


Der Baum ist rechtstief entartet, also eigentlich eine sortierte
Liste.  Die Suche wird potentiell durch die ganze Liste Laufen, im
Schnitt durch die halbe Liste.

Wir brauchen einen einigermaßen balancierten Baum!


Idee: Angenommen wir hätten schon eine sortierte Liste:

    [ 1, 2, 3, 4, 5, 6 ]

Diese wird um `undefined` erweitert

    [ 1, 2, 3, 4, 5, 6, undefined ]

und in Paare mit (anfangs leeren Bäumen) umgewandelt:

    [ (E, 1), (E, 2), (E, 3), (E, 4), (E, 5), (E, 6), (E, undefined) ]

und diese werden dann paarweise zu neuen Paaren verschmolzen.

    [ (E, 1), (E, 2), (E, 3), (E, 4), (E, 5), (E, 6), (E, undefined) ]
        \     /         \     /         \     /
    [ (  `1--'  , 2), (  `3--'  , 4), (  `5--'  , 6), (E, undefined) ]
           \             /                 \          /
    [ (     `-----2-----'       , 4), (     `-----6--'  , undefined) ]
                   \                             /
    [ (             `-------------4-------------'       , undefined) ]

Bis nur noch ein Paar übrig bleibt.  Seine erste Komponente enthält
den Baum, das `undefined` werfen wir wieder weg.

> fromAscList' :: [a] -> BinTree a
> fromAscList' = repeat . map ((,) Empty) . (++ [undefined])
>     where
>     repeat [(l,_)] = l -- `_` ist das `undefined` von oben!
>     repeat other = repeat $ join other
>         where
>         join :: [(BinTree a, a)] -> [(BinTree a, a)]
>         join ((l,x):(r,y):zs) = (Node l x r, y) : join zs
>         join zs = zs

Ausprobieren:

    fromAscList' [1..15]


Tatsachlich kann man `undefined` auch an den Anfang stellen, und
vermeidet damit das Anti-Pattern `++[…]`:

    [ (E, ⊥), (E, 1), (E, 2), (E, 3), (E, 4), (E, 5), (E, 6) ]
        \     /         \     /         \     /
    [ (  `-1-' , ⊥ ), (  `-3-' , 2 ), (  `-5-' , 4 ), (E, 6) ]
            \             /                 \         /
    [ (      `-----2-----'   ,   ⊥ ), (      `---6---' ,  4) ]
                    \                           /
    [ (              `------------4------------'     ,   ⊥ ) ]

> fromAscList :: [a] -> BinTree a
> fromAscList = repeat . map ((,) Empty) . (undefined:)
>     where
>     repeat [(l,_)] = l -- `_` ist das `undefined` von oben!
>     repeat other = repeat $ join other
>         where
>         join :: [(BinTree a, a)] -> [(BinTree a, a)]
>         join ((l,x):(r,y):zs) = (Node l y r, x) : join zs
>         join zs = zs



Zurück zur Aufgabe:

Ein Eintrag in der Tabelle soll ein Paar aus Schlüssel (Char) und Wert
(Bitfolge) sein.

    =>  BinTree (Char, [Bit])


Der `HuffTree` lässt sich recht einfach in eine Liste aller Buchstaben
und passender Codes übersetzen:

> codeList :: HuffTree -> [(Char, [Bit])]
> codeList = go []
>     where
>     go bs (Leaf c) = [(c, reverse bs)]
>     go bs (l :^: r) = go (L:bs) l ++ go (R:bs) r

    codeList en

Damit ist der Suchbaum einfach

> table :: HuffTree -> BinTree (Char, [Bit])
> table = fromAscList . sort . codeList

wobei ich die Sortierfunktion `sort` aus Data.List verwendet habe.  Es
ginge aber auch `mergesort`, weil wir ja keine Duplikate haben.

    table en



Nachricht codieren: Falls ein Zeichen `z` nicht codiert werden kann
weil es nicht im Lookup-Table steht, mit Fehlermeldung abbrechen.

> encodeMessage' :: HuffTree -> String -> [Bit]

> encodeMessage' root = concatMap enc
>     where
>     t = table root
>     enc c = maybe (error $ "bad character: "++show c) id $ find c t

    encodeMessage' en "hello wordld!  how are you?"
    decodeMessage en it



Plan III: Das Modul `Data.Map.Strict` implementiert effiziente
^^^^^^^^^ Lookup-Tables.  Dokumentation im Netz [1].

Funktioniert wie Plan II, verwendet aber nicht `BinTree (Char,
[Bit])`, sondern `M.Map Char [Bit]` als Lookup-Table...

> encodeMessage'' :: HuffTree -> String -> [Bit]

> encodeMessage'' root = concatMap enc
>     where

      ...das Mapping können wir aus einer Liste von Paaren erzeugen
      lassen...
      M.fromList :: Ord k => [(k, a)] -> M.Map k a

>     table = M.fromList $ codeList root

      ...statt  find  wird  M.lookup  verwendet.
      M.lookup :: Ord k => k -> M.Map k a -> Maybe a

>     enc c = maybe (error $ "bad character: "++show c) id
>             $
>             M.lookup c table

    encodeMessage'' en "hello wordld!  how are you?"
    decodeMessage en it


----------------------------------------------------------------------
Eigene Programme Compilieren


Der Compiler sucht immer nach einer Funktion `main` im `Main`-Modul,
die er ausführen kann.  Deswegen steht ganz oben in dieser Datei

    module Main where

Die `main`-Funktion muss einen besonderen Typ haben:

> main :: IO ()        -- Was das bedeutet, sehen wir diese Woche noch

Die Funktion

    interact :: (String -> String) -> IO ()

übernimmt eine Funktion, die die Eingabe des Programmes auf `stdin`
konsumiert, und deren Ausgabe auf `stdout` geschrieben wird.

Was tut also folgendes

> main = interact $ show . length


Compilieren und testen:

    $ ghc pk2-11.lhs
    $ date | ./pk2-11



Die Ausgabe wäre mit Zeienumbruch schöner.  Wie kann man das
verbessern?





> mainLn :: IO ()
> mainLn = interact $ (++"\n") . show . length

Beim Compilieren kann man eine alternative `main`-Funktion angeben:

    $ ghc -main-is mainLn pk2-11.lhs
    $ date | ./pk2-11


----------------------------------------------------------------------
Space Leaks und strikte Auswertung


Aufgabe: Gegeben ein riesiger Text.  Zähle die Zeichen, Worte, und
         Zeilen (analog zu wc(1)).


> wc0 xs = (c,w,l)
>     where 
>     c = length xs
>     w = length $ words xs
>     l = length $ lines xs

> main0 :: IO ()
> main0 = interact $ (++"\n") . show . wc0

Testen:

    ghc -main-is main0 pk2-11.lhs

    ./pk2-11 <small.txt
    ./pk2-11 <medium.txt
    ./pk2-11 <large.txt

Wir starten das programm mit einem etwas engeren Speicherlimit
(cf. bash(1) /ulimit):

    ulimit -v 2500000   # 2.5GB

    ./pk2-11 <large.txt


Der Nachteil der bisherigen Zählfunktion `wc0`:
    
    Die Eingabe wird dreimal durchlaufen.  Ausserdem: Beachte den
    Speicherbedarf...



Das versuchen wir im Folgenden zu verbessern.

> step :: (Bool, Int, Int, Int) -> Char -> (Bool, Int, Int, Int)

Zähle einen weiteren Buchstaben `x`.  Das Tripel `(c,w,l)` sind die
Zähler als akkumulierender Parameter.  Nicht jedes Leerzeichen
begrenzt dabei ein Wort, sondern nur diejenigen, deren vorausgehendes
kein Leerzeichen war.  `e` gibt an ob ein Leerzeichen ein Wort beenden
würde.

> step (e,c,w,l) x
>     | x=='\n'
>         = (False, c+1, if e then w+1 else w, l+1)
>     | isSpace x
>         = (False, c+1, if e then w+1 else w, l)
>     | otherwise
>         = (True, c+1, w, l)

Die Zählfunktion muss dann noch prüfen ob das Ende der Eingabe auch
ein Wort beendet.:

> wc1 :: String -> (Int,Int,Int)
> wc1 xs = if e then (c,w+1,l) else (c,w,l)
>     where
>     (e,c,w,l) = foldl step (False,0,0,0) xs

> main1 :: IO ()
> main1 = interact $ (++"\n") . show . wc2

    ghc -main-is main1 pk2-11.lhs

    ./pk2-11 <small.txt
    ./pk2-11 <medium.txt
    ./pk2-11 <large.txt



Wo liegt das Problem?

    foldl (+) 0 [1..1000000000]

Die nicht strikte Auswertung verzögert die Addition so lange, bis ihr
Ergebnis gebraucht wird, also bis zur Ausgabe:

    foldl (+) 0 $ [1..1000000000]
  →
    foldl (+) 0 $ 1:[2..1000000000]
  →
    foldl (+) (0+1) $ 2:[3..1000000000]
  →
    foldl (+) (0+1+2) $ 3:[4..1000000000]
  →
    foldl (+) (0+1+2+3) $ 4:[5..1000000000]
               ^^^^^^^

Intern wird ein riesiger Baum aufgebaut, der den arithmetischen
Ausdruck darstellt.

Dieses Problem ist als “space leak” bekannt.



Wir brauchen strikte Auswertung!

Die Funktion

    seq :: a -> t -> t

erzwingt die Reduktion des ersten Arguments auf WHNF, und gibt das
Zweite zurück. Vergleiche

    :t (\x y -> y)
    (\x y -> y) undefined True

und

    :t seq
    seq undefined True
    seq (1+2) True

Obacht: Diese Eigenschaft von `seq` läßt sich nicht im λ-Kalkül
        ausdrücken.  Sie ist im Compiler fest verdrahtet: Compiler
        Magic!

Eine handlichere Version ist der strikte Anwendungs-Operator

    ($!) :: (a -> b) -> a -> b
    f $! x = x `seq` f x

der bei der Anwendung `f x` die Reduktion des Arguments `x` auf WHNF
erzwingt.  Der Effekt von `seq` beruht aus Sharing!

Vergleiche

    const 3 $ length [1..]

mit

    const 3 $! length [1..]


Das Modul `Data.List` beherbergt die Funktion `foldl'`

> foldl' :: (t -> t1 -> t) -> t -> [t1] -> t
> foldl' f z []     = z
> foldl' f z (x:xs) = (foldl' f $! f z x) xs

sie reduziert `f z x` auf WHNF, bevor `foldl'` rekursiv aufgerufen
wird.  Vergleiche:

    foldl f z []     = z
    foldl f z (x:xs) = (foldl f $ f z x) xs

Damit:    

    foldl  (+) 0 [1..10000000]          -- ☠
    foldl' (+) 0 [1..10000000]          -- ✓
    foldl' (+) 0 [1..1000000000]        -- ✓



Können wir damit unsere Funktion `wc1` verbessern?

> wc2 :: String -> (Int,Int,Int)

> wc2 xs = if e then (c,w+1,l) else (c,w,l)
>     where

      Verwenden das striktere `foldl'` um `step` auf den Input
      anzuwenden:

>     (e,c,w,l) = foldl' step (False,0,0,0) xs



> main2 :: IO ()
> main2 = interact $ (++"\n") . show . wc2


    ghc -main-is main2 pk2-11.lhs

    ./pk2-11 <small.txt
    ./pk2-11 <medium.txt
    ./pk2-11 <large.txt


Das scheint nicht auszureichen.  Bei genauerer Betrachtung sieht man,
dass wir die WHNF an der falschen Stelle erzwingen:

    foldl' step (False,0,0,0) $ 'a':"bcd…
  →
    (foldl' step $! step (False,0,0,0) 'a') $ "bcd…
  →
    (foldl' step $! (True, 0+1, w, l) ) $ "bcd…
                    ^^^^^^^^^^^^^^^^^
                      Das ist WHNF!
  →    
    (foldl' step $! (True, 0+1, w, l)) $ 'b':"cde…
  →
    (foldl' step $! step (True, 0+1, w, l) 'b') $ "cde…
  →
    (foldl' step $! (True, 0+1+1, w, l) ) $ 'c':"def…
                    ^^^^^^^^^^^^^^^^^^^
                       Das ist WHNF!
  →
    (foldl' step $! (True, 0+1+1+1, w, l)) $ 'd':"efg…
                    ^^^^^^^^^^^^^^^^^^^^^^
                         Das ist WHNF!
  →
    ...

Wir müssen die Komponenten des Tupels strikt auswerten!  Dazu bauen
wir eine Hilfsfunktion `force`, die die Komponenten auf WHNF reduziert
bevor ein Tupel daraus konstruiert wird:

> step' (e,c,w,l) x
>     | x=='\n'
>         = force False (c+1) (if e then w+1 else w) (l+1)
>     | isSpace x
>         = force False (c+1) (if e then w+1 else w) l
>     | otherwise
>         = force True (c+1) w l
>     where
>     force e c w l = e `seq` c `seq` w `seq` l `seq` (e,c,w,l)

Nebenbei: Die Spracherewiterung `BangPatterns` erweitert die
Pattern-Syntax um strikteArgumente mit einem `!` zu markieren

      force !e !c !w !l = (e,c,w,l)


> wc3 :: String -> (Int,Int,Int)
> wc3 xs = if e then (c,w+1,l) else (c,w,l)
>     where

      Verwenden `foldl'` und außerdem `step'`:

>     (e,c,w,l) = foldl' step' (False,0,0,0) xs



> main3 :: IO ()
> main3 = interact $ (++"\n") . show . wc3

Prima (endlich):

    ghc -main-is main3 pk2-11.lhs

    ./pk2-11 <small.txt
    ./pk2-11 <medium.txt
    ./pk2-11 <large.txt



Obacht: End-Rekursion und Strikte Auswertung sind nicht immer die
        beste Lösung:

    length . foldr (++) [] $ [[x] | x <- [1..10000000]]

Wieso geht das so schnell?  Und mit so wenig Speicher?

Nicht-strikte Auswertung!

    foldr (++) [] $ [[x] | x <- [1..10000000]]
  →
    foldr (++) [] $ [1]:[[x] | x <- [2..10000000]]
  →
    (1:[]) ++ (foldr (++) [] $ [[x] | x <- [2..10000000]])
  →
    1 : ([] ++ (foldr (++) [] $ [[x] | x <- [2..10000000]]))  -- WHNF

Solange `length` die 1 nicht konsumiert, wird dieser Ausdruck nicht
weiter reduziert.  `length` selbst ist intern strikt konstruiert in
dem Sinne, daß es *keine* Summe der Form 0+1+1+1+1+1+... aufbaut.

    length [1..1000000000]

    

Wichtiges Konzept: Guarded Recursion [2]:

    Jeder rekursive Aufruf geschieht innerhalb einer
    Konstruktorfunktion.

Vgl. oben: Der rekursive Aufruf von `foldr` passiert rechts vom `:`
Operator.

  * Der Ausdruck wird also *nur bis zum Konstruktor* reduziert und ist
    dann in WHNF,

  * der rekursive Aufruf wird in den konstruierten Daten versteckt.

  * Ein Konsument (aufrufende Funktion) kann dann entscheiden ob er
    mehr Daten braucht.


Die Entscheidung fällt also zwischen

  foldr — lazy, potentiell unendliche Strukturen.

  foldl' — konsumiert ganze Struktur, erzwingt WHNF des
           akkumulierenden Parameters.

Es gibt kaum einen Grund die nicht-strikte Variante `foldl` zu
verwenden.


----------------------------------------------------------------------
References


[1] Data.Map.Strict
    https://hackage.haskell.org/package/containers-0.5.7.1/docs/Data-Map-Strict.html
[2] Haskell Wiki: Tail recursion.
    http://www.haskell.org/haskellwiki/Tail_recursion

======================================================================
