
Konzepte der Programmierung                       Universität Konstanz
Programmierkurs 2                Informatik & Informationswissenschaft
Sommer 2016                                Marc Scholl, Stefan Klinger

======================================================================

                             11. Juli 2016

----------------------------------------------------------------------


  * `pub/lecture_complete.pdf` enthält den desamten Foliensatz.

  * Fragestunde zur Klausur: Dienstag (morgen).  Bereiten Sie Fragen
    vor:

        ✓  “Wie geht das nochmal?”
        
        ☠  “Was kommt dran?”

  * Klausur vom Sommer 2013 in `pub/extras/exam1_s13.pdf`.  Die letzte
    Aufgabe bezieht sich auf Prolog, das kommt natürlich nicht dran.
    Die Musterlösung lade ich in ein paar Tagen hoch.


----------------------------------------------------------------------
Sich Werte aus dem Ärmel ziehen...


Folie 500: `(τ, )` lässt sich nicht “ohne Weiteres” als applicativer
           Funktor auffassen.

Aber:

    class Functor f => Applicative f where
    [...]
    instance Monoid a => Applicative ((,) a)

dafuq?

Erinnerung: Das Problem war sich einen Wert für die erste Komponente
            zu überlegen.

> data Pair a b = P a b

> instance Functor (Pair t) where
>   fmap f (P k x) = P k (f x)

 > instance Applicative (Pair t) where
 >   pure x = P  __k__  x
 >   u <*> v = __ap__

Für manche Typen kann man sich ein “ausgezeichnetes Element”
überlegen.  Mathematische Struktur dazu: Monoid.

  “ Ein Monoid ist eine Menge M mit einem ausgezeichneten Element
    e ∈ M, und einer inneren Verknüpfung # : M × M → M, so dass gilt

      ∀x y z. (x # y) # z = x # (y # z)        -- (Assoz)

      ∀x. e # x = x = x # e                    -- (Neut)

    dabei quantifiziert ∀ über die Elemente von M.
  ”                                                   — Wikipedia [1]

Beispiel: Die Natürlichen Zahlen mit e = 0, und (#) = (+).

Die Klasse `Monoid` manifestiert diese Idee:

    *Main> :i Monoid
    class Monoid a where
      mempty :: a                -- Neutralelement
      mappend :: a -> a -> a     -- Verknüpfung

Bei einer Instanziierung zu `Monoid` muss man die Gesetze
beweisen!


Beispiele, die Ringstruktur [2] der ganzen Zahlen liefert direkt die
Gesetze.

> instance Monoid Integer where
>   mempty = 0
>   mappend = (+)

… leider müssen wir uns für eins von beiden entscheiden …
     
 > instance Monoid Integer where
 >   mempty = 1
 >   mappend = (*)


Schon vordefiniert ist

    instance Monoid [a] -- Defined in ‘GHC.Base’

wie geht das wohl?
 
    mempty :: [a]
    mempty = []

    mappend :: [a] -> [a] -> [a]
    mappend = (++)


> instance Monoid t => Applicative (Pair t) where

>   pure y = P mempty y

>   P k f <*> P h x = P (mappend k h) (f x)

Beweis der Applicative-Gesetze:

1.    pure id <*> P h x
    =                                  — Def `pure`
      P mempty id <*> P h x
    =                                  — Def `<*>`
      P (mappend mempty h) (id x)
    =                                  — (Neut)
      P h (id x)
    =                                  — Def `id`
      P h x

Die restlichen Gesetze sind genauso einfach, bei 3, 4, 5 am besten von
beiden Seiten her rechnen, bei 4 brauchen wir tatsächlich (Assoz).


----------------------------------------------------------------------
Parsec — Combinator library for parser construction.


=> Datei `calculator.lhs`

----------------------------------------------------------------------

[1] https://de.wikipedia.org/wiki/Monoid#Definition
[2] https://en.wikipedia.org/wiki/Ring_(mathematics)#Definition

======================================================================
